#!/usr/bin/python

import sys,re,os;

def toppredres2top(strResFile, strOutFile, lstXs = None) :
    lstTMs = [];
    strSeqName = '';
    intLength = 0;
    strNterm = '';
    flhRes = file(strResFile);
    for strLine in flhRes :
        m = re.match('Sequence : (\w+)\s+\((\d+) res\)', strLine);
        if m :
            strSeqName = m.group(1);
            intLength = int(m.group(2));
            continue ;
        if strLine.startswith('Found: 0 segments') :
            strNterm = 'out'; # arbitrary
            break ;
        m = re.match('TOPOLOGY\s+(\?\s+)*N-(out|in)', strLine); # not always present
        if m :
            strNterm = m.group(2);
            continue ;
        m = re.match('(CYT|EXT)_LOOP\s+1\s+\d+\s+\d+', strLine); # The '1' assures first loop-entry
        if m and strNterm == '' :
            if m.group(1) == 'CYT' : strNterm = 'in';
            else :                   strNterm = 'out';
            continue ;
        m = re.match('TRANSMEM\s+(\d+)\s+(\d+)\s+(\d+)', strLine);
        if m :
            intStart = int(m.group(1));
            intEnd = int(m.group(2));
            intTMLength = int(m.group(3));
            lstTMs.append([intStart, intEnd, intTMLength]);
            continue ;
        if strLine.startswith('//') :
            break ;
    flhRes.close();
    def toggle(chr) :
        if chr == 'o' : return 'i';
        return 'o';
    strTop = '';
    chrTop = strNterm[0];
    for TM in lstTMs :
#        print strTop;
        strTop += chrTop * (TM[0] - len(strTop) - 1) + 'M' * TM[2];
        chrTop = toggle(chrTop);
    strTop += chrTop * (intLength - len(strTop));

    if lstXs :
#         print >>sys.stderr, strSeqName;
#         print >>sys.stderr, strTop;
        for i in lstXs :
            strTop = strTop[:i] + 'X' + strTop[i:];
#        print >>sys.stderr, strTop;

    flhOut = file(strOutFile, 'w');
    print >>flhOut, ">%s\n%s" % (strSeqName, strTop);
    flhOut.close();

def findFastaX(strFastaFile) :
    flhFasta = file(strFastaFile);
    strSeq = "".join([s.strip() for s in flhFasta.readlines()[1:]]);
    flhFasta.close();
    lstXs = [];
    for i in range(len(strSeq)) :
        if strSeq[i] in 'Xx' :
            lstXs.append(i);
    return lstXs;


if __name__ == '__main__' :
    strUsage = "Usage: %s <toppred result file> <output file>";
    if ( len(sys.argv) < len(strUsage.split('<')) ) :
        print strUsage % os.path.basename(sys.argv[0]);
        sys.exit(1);

    try :
        toppredres2top(sys.argv[1], sys.argv[2]);
    except :
        print >>sys.stderr, sys.argv;
        raise ;
